//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

//
// WARNING: Generated file, do not edit by hand!
//

/** \file inst/mfc0.hh
    \brief Declare the interface of Mfc0 */
#ifndef INST_MFC0_HH
# define INST_MFC0_HH
# include "inst/register.hh"
# include "inst/exp.hh"
# include "inst/inst.hh"

namespace inst
{

  /// Declare Mfc0.
  /** Move the contents of control coprocessor src register 
to CPU dest register.  */
  class Mfc0:
    public Inst
  {
    /** \name Ctor & dtor.
        \{ */
  public:
    /// Construct a(n) Mfc0 node.
    Mfc0(const Register &dest, const Register &src);
    /// Destroy a(n) Mfc0 node.
    virtual ~Mfc0();
    /** \} */

    /** \name Accessors.
        \{ */
  public:
    /// Return dest
    const Register &		get_dest() const ;
    /// Return dest
    Register &		get_dest() ;
    /// Return src
    const Register &		get_src() const ;
    /// Return src
    Register &		get_src() ;
    /** \} */

    /** \name Visitors entry point.
        \{ */
  public:
    /// Accept a const visitor \a v.
    virtual void accept(ConstVisitor& v) const;
    /// Accept a non-const visitor \a v.
    virtual void accept(Visitor& v);
    /** \} */

  public:
    /// Print this
    virtual void	write(std::ostream &ostr) const;

  protected:
    Register	dest_;
    Register	src_;
  };

} // namespace inst

# include "inst/mfc0.hxx"

#endif // !INST_MFC0_HH
