//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2005, 2006 Akim Demaille <akim@epita.fr> and
//                          Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef TASK_STRING_TASK_HH
# define TASK_STRING_TASK_HH

# include <string>

# include "task/task.hh"

namespace task
{

  class StringTask:
    public Task
  {
  public:
    StringTask(void (*execute)(const std::string &),
               const std::string &option, const std::string &module_name,
               const std::string &desc, const std::string &deps = "");

  public:
    virtual bool set_value(const std::string &value) const;

    virtual void execute() const;

  private:
    void (*execute_)(const std::string &);

    mutable std::string s_;
  };

} // namespace task

#endif // !TASK_STRING_TASK_HH
